
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring4.0系列5-@Conditional / iVAN</title>

    <meta name="description" content="Spring4.0系列5-@Conditional 这篇文章介绍spring 4的@Conditional注解.在Spring的早期版本你可以通过以下方法来处理条件问题: 3.1之前的版本,使用Spring Expression Language(SPEL). 3.1版本有个新特性叫profile,用来解决条件问题. 1.Spring Expression Language(SPEL) SPEL有一个三元运算符(if-then-else)可以在配置文件中当作条件语句,如下: Java代码   &lt;bean id=&quot;flag&quot ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spring4.0系列5-@Conditional</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>这篇文章介绍<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">spring</a> 4的@Conditional注解。在Spring的早期版本你可以通过以下方法来处理条件问题：</p>
<ul>
<li>3.1之前的版本，使用Spring Expression Language（SPEL）。</li>
<li>3.1版本有个新特性叫profile，用来解决条件问题。</li>
</ul>
<h1>1、Spring Expression Language（SPEL）</h1>
<p>SPEL有一个三元运算符(if-then-else)可以在配置文件中当作条件语句，如下：</p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>&lt;bean id="flag"&gt;  </li>
<li>   &lt;constructor-arg value="#{systemProperties['system.propery.flag'] ?: false }" /&gt;  </li>
<li>&lt;/bean&gt;  </li>
<li>&lt;bean id="testBean"&gt;  </li>
<li>    &lt;property name="prop" value="#{ flag ? 'yes' : 'no' }"/&gt;  </li>
<li>&lt;/bean&gt;  </li>
</ol>
<p> testBean的prop动态依赖于flag的值。</p>
<h1>2、使用Profile</h1>
<p>Xml代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>&lt;!-- 如果没有设置profile,default.xml将被加载 --&gt;  </li>
<li>&lt;!-- 必须放置在配置文件的最底下，后面再也没有bean的定义 --&gt;  </li>
<li>&lt;beans profile="default"&gt;  </li>
<li>     &lt;import resource="classpath:default.xml" /&gt;  </li>
<li>&lt;/beans&gt;  </li>
<li>&lt;!-- some other profile --&gt;  </li>
<li>&lt;beans profile="otherProfile"&gt;  </li>
<li>    &lt;import resource="classpath:other-profile.xml" /&gt;  </li>
<li>&lt;/beans&gt;  </li>
</ol>
<p> </p>
<h1>3、使用@Conditional</h1>
<p>官方文档定义：“Indicates that a component is only eligible for registration when all <a href="http://docs.spring.io/spring/docs/current/javadoc-api/org/springframework/context/annotation/Conditional.html#value--" rel="external nofollow noreferrer">specified conditions</a> match”，意思是只有满足一些列条件之后创建一个bean。</p>
<p>@Conditional定义</p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>@Retention(RetentionPolicy.RUNTIME)  </li>
<li>@Target(ElementType.TYPE, ElementType.METHOD)  </li>
<li>public @interface Conditional{  </li>
<li>lass &lt;!--?extends Condition--&gt;[] value();  </li>
<li>}  </li>
</ol>
<p> </p>
<p>@Conditional注解主要用在以下位置：</p>
<ul>
<li>类级别可以放在注标识有@Component（包含@Configuration）的类上</li>
<li>作为一个meta-annotation,组成自定义注解</li>
<li>方法级别可以放在标识由@Bean的方法上</li>
</ul>
<p><strong>如果一个@Configuration的类标记了@Conditional，所有标识了@Bean的方法和@Import注解导入的相关类将遵从这些条件。</strong></p>
<p> </p>
<p>condition接口定义如下：</p>
<p> </p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>public interface Condition{  </li>
<li>/** Determine if the condition matches. </li>
<li>* @param context the condition context </li>
<li>* @param metadata meta-data of the {@link AnnotationMetadata class} or </li>
<li>* {@link Method method} being checked. </li>
<li>* @return {@code true} if the condition matches and the component can be registered </li>
<li>* or {@code false} to veto registration. </li>
<li>*/  </li>
<li>boolean matches(ConditionContext context, AnnotatedTypeMedata metadata);  </li>
<li>}  </li>
</ol>
<p> </p>
<p>下面看一个例子：</p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>import org.springframework.context.annotation.Condition;  </li>
<li>import org.springframework.context.annotation.ConditionContext;  </li>
<li>import org.springframework.core.type.AnnotatedTypeMetadata;  </li>
<li>   </li>
<li>public class LinuxCondition implements Condition{  </li>
<li>   </li>
<li>  @Override  </li>
<li>  public boolean matches(ConditionContext context, AnnotatedTypeMetadata metadata) {  </li>
<li>    return context.getEnvironment().getProperty("os.name").contains("Linux");  }  </li>
<li>}  </li>
</ol>
<p> </p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>import org.springframework.context.annotation.Condition;   </li>
<li>import org.springframework.context.annotation.ConditionContext;   </li>
<li>import org.springframework.core.type.AnnotatedTypeMetadata;   </li>
<li>   </li>
<li>public class WindowsCondition implements Condition{  </li>
<li>   </li>
<li>  @Override   </li>
<li>  public boolean matches(ConditionContext context, AnnotatedTypeMetadata metadata) {  </li>
<li>    return context.getEnvironment().getProperty("os.name").contains("Windows");  </li>
<li>  }  </li>
<li>}  </li>
</ol>
<p> </p>
<p>我们有两个类LinuxCondition 和WindowsCondition 。两个类都实现了Condtin接口，重载的方法返回一个基于操作系统类型的布尔值。</p>
<p> </p>
<p>下面我们定义两个bean，一个符合条件另外一个不符合条件：</p>
<p>Java代码  <a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd2lzZWx5bWFuLml0ZXllLmNvbS9pbWFnZXMvaWNvbl9zdGFyLnBuZw==.jpg"></a></p>
<ol>
<li>import org.springframework.context.annotation.Bean;  </li>
<li>import org.springframework.context.annotation.Conditional;  </li>
<li>import org.springframework.context.annotation.Configuration;  </li>
<li>   </li>
<li>@Configuration  </li>
<li>public class MyConfiguration {  </li>
<li>   </li>
<li>  @Bean(name="emailerService")  </li>
<li>  @Conditional(WindowsCondition.class)  </li>
<li>  public EmailService windowsEmailerService(){  </li>
<li>      return new WindowsEmailService();  </li>
<li>  }  </li>
<li>   </li>
<li>  @Bean(name="emailerService")  </li>
<li>  @Conditional(LinuxCondition.class)  </li>
<li>  public EmailService linuxEmailerService(){  </li>
<li>    return new LinuxEmailService();  </li>
<li>  }  </li>
<li>}  </li>
</ol>
<p> </p>
<p> 当符合某一个条件的时候，这里的@Bean才会被初始化。 </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:16:30</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spring4.0系列5-@Conditional的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJqOwvp.html" rel="bookmark">Spring4&period;0系列6-Generic Qualifier（泛型限定）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Spring4.0里,泛型是可以用来决定哪一个bean需要依赖注入的(无论xml配置还是注解配置). 用一个简单的例子解释.假设你有一个使用了泛型的DAO.   Java代码   public class Dao&lt;T&gt; {     ...   }    现在创建两个实现类的bean: Java代码   import org.springframework.context.annotation.Bean;   import org.springframework.context.annotat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZQQAz.html" rel="bookmark">Spring4&period;0系列4-Meta Annotation（元注解）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring框架自2.0开始添加注解的支持,之后的每个版本都增加了更多的注解支持.注解为依赖注入,AOP(如事务)提供了更强大和简便的方式.这也导致你要是用一个相同的注解到许多不同的类中去.这篇文章介绍meta annotation来解决这个问题. Meta Annotation(元注解)定义 Spring4.0的许多注解都可以用作meta annotation(元注解).元注解是一种使用在别的注解上的注解.这意味着我们可以使用Spring的注解组合成一个我们自己的注解. 创建组合注解 自定义注			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zG1WynM.html" rel="bookmark">Spring4&period;0系列7-Ordering Autowired Collections</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring 4.0的一个小特性是在自动注入的时候使用@Order.Spring 2.5中,我们将bean注入List,如下代码: Java代码   import org.springframework.stereotype.Component;   @Component   public class Employee implements Person {   }     Java代码   import org.springframework.stereotype.Component;   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgwDxAM.html" rel="bookmark">Spring4&period;0系列8-Groovy DSL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4.0的一个重要特征就是完全支持Groovy,Groovy是spring主导的一门基于JVM的脚本语言(动态语言).在spring 2.x,脚本语言通过 Java scripting engine在Spring中得到支持.而在4.0中,Groovy的变得更重要,Groovy可以替换xml和注解用来作为bean配置. 要使用Groovy,首先用maven下载Groovy的包,pom.xml文件中添加: Xml代码   &lt;dependency&gt;    &lt;groupId&gt;org.code			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boqKVEp.html" rel="bookmark">Spring4&period;0系列9-websocket简单应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring 4.0的一个最大更新是增加了websocket的支持.websocket提供了一个在web应用中的高效.双向的通讯,需要考虑到客户端(浏览器)和服务器之间的高频和低延时消息交换.一般的应用场景有:在线交易.游戏.协作.数据可视化等.   使用websocket需要考虑的浏览器的支持(IE&lt;10不支持),目前主流的浏览器都能很好的支持websocket. websocket协议中有一些子协议,可以从更高的层次实现编程模型,就像我们使用HTTP而不是TCP一样.这些子协议有STOMP,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnO2moz.html" rel="bookmark">Spring4&period;0系列3-&commat;RestController</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4.0重要的一个新的改进是@RestController注解,它继承自@Controller注解.4.0之前的版本,spring MVC的组件都使用@Controller来标识当前类是一个控制器servlet.   使用这个特性,我们可以开发REST服务的时候不需要使用@Controller而专门的@RestController.     当你实现一个RESTful web services的时候,response将一直通过response body发送.为了简化开发,Spring 4.0提供了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQ08np.html" rel="bookmark">&lbrack;CXF REST标准实战系列&rsqb; 二、Spring4&period;0 整合 CXF3&period;0&comma;实现测试接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Reprint it anywhere u want. 文章Points: 1.介绍RESTful架构风格 2.Spring配置CXF 3.三层初设计,实现WebService接口层 4.撰写HTTPClient 客户端,并实现简单调用     介绍RESTful架构风格     REST是REST之父Roy Thomas创造的,当时提出来了REST的6个特点:客户端-服务器的.无状态的.可缓存的.统一接口.分层系统和按需编码.其具有跨语言和跨平台的优势.     REST是一种架构风格.其描述			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVjlVz.html" rel="bookmark">ActionScript 3&period;0系列教程&lpar;4&rpar;：爽快使用XML</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				xml|教程 ActionScript 3.0系列教程(3):Document Class特色为我们带来了什么? ActionScript 3.0系列教程(4):爽快使用XML 为什么放弃AS2.0选择AS3.0?如果只允许我说三个理由.那么AS3.0对XML的近乎完美的支持绝对是其中一个. 简单说说AS3.0中对于XML支持的不同吧: .AS2.0对XML的支持勉勉强强,将就着可以用.而AS3.0中对XML的支持是全方位的,极其强大和灵活的. AS2.0对XML的支持不是内建的(build-i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqxLKb.html" rel="bookmark">Flash ActionScript 3&period;0系列教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				教程 作者的blog: www.kingda.org ActionScript 3.0系列教程(1):与Flash9先来一次亲密接触! Flash Professional 9 ActionScript 3.0 Preview 版本今天发布了,意味着从此我们从此不仅仅只能使用Flex 2来使用AS3.0,更可以使用我们一直很熟悉的Flash IDE来进行AS3.0开发了. 与Flex 2不同,Flash 9 alpha(即上面的Flash Professional 9 ActionScript			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAYGXM.html" rel="bookmark" class="title">利用图案图章及混合器画笔工具把人物转油画效果</a>
					<div>
						这里介绍一种手工制作油画效果的方法,非常实用.过程:打开想要的素材,并定义成图案:然后新建图层,用图案图章工具配合合适的笔刷把人物主要部分涂出来,局部修改属性后涂出初步的绘画痕迹:再用混合器画笔增加细 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR9PBb.html" rel="bookmark" class="title">百度搜索结果参数F2与搜索结果标题的关系</a>
					<div>
						在我刚学习SEO的时候就有这样一个疑问:淘宝不是明明屏蔽了百度搜索引擎了吗,怎么搜索淘宝,淘宝网怎么还能搜到,而且还排在第一? 搜索淘宝 而且我们可以发现&quot;淘宝网&quot;并不是淘宝的网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMymGlM.html" rel="bookmark" class="title">Struts学习笔记&colon; Bean标签库学习</a>
					<div>
						笔记 Bean标签库 1. &lt;bean:header&gt;  #0968F7     &lt;bean:header id=&quot;custlang&quot; name=&quot;Ac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJNA4z.html" rel="bookmark" class="title">c&num;高級編程記錄--第一章</a>
					<div>
						C#有一個基於值類型和引用類型之間區別為基礎的類型系統: 相關概念:CLR.受管制代碼.非受管制代碼.CTS.CLS.裝配件.反射.裝配件清單.應用域.無用存儲單元收集 .NET程序包含多個裝配件,其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAxKJb.html" rel="bookmark" class="title">浅谈作为一名成功的优化人员你所不能缺失的技能</a>
					<div>
						对于优化,在互联网早期我们可能会认为是一项比较神秘的职业,但随着互联网的发展,搜索引擎的不断更新,现在的搜索引擎优化变得非常的普及,对于优化的知识,在笔者看来都是一些不难的知识,门槛相对于其他行业来说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPWlKz.html" rel="bookmark" class="title">为什么电脑使用每隔一段时间会重启</a>
					<div>
						问:我的电脑是P4 1.5GHz,我装的是Windows XP操作系统,可是使用过程中每隔2小时,我的电脑就会重新启动,请问这是怎么回事? 答:首先,你可以用新版杀毒软件检查有没有木马.病毒程序,另外 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6OVDz.html" rel="bookmark" class="title">C&num;中的abstract与virtual</a>
					<div>
						abstract abstract 修饰符可以和类.方法.属性.索引器及事件一起使用. 在类声明中使用 abstract 修饰符以指示类只能是其他类的基类. 抽象类具有以下特性: ·抽象类不能实例化. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLO2kZM.html" rel="bookmark" class="title">java上传附件到文件系统</a>
					<div>
						图片,word,text文件在数据库中是不能以varchar2类型存储的,在orca中以clob,blob类型存储.在SqlServer中以img,txt类型存储.把附件存储在数据库中的好处是附件不容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EXPKM.html" rel="bookmark" class="title">Mac误删照片怎么恢复</a>
					<div>
						  EasyRecovery是由全球著名数据厂商Kroll Ontrack出品的数据恢复软件,支持各种不同存储介质的数据恢复,官网上有针对Mac专门开发的版本.Mac误删照片怎么恢复?我们选择下载Ea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3j71p.html" rel="bookmark" class="title">优化分支网站：二级域名与二级目录利弊选取</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 网站运营发展到一定规模后,为了提升 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLalBWz.html" rel="bookmark" class="title">服务器-Windows 2008 R2 开机进入不了系统</a>
					<div>
						问题描述 Windows 2008 R2 开机进入不了系统 机器一共两块网卡,我禁用了一块,然后就开不了机了,一直卡在DHCP上转圈.怎么才可以引导进去呢? 解决方案 WINDOWS2008R2系统M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLZW5b.html" rel="bookmark" class="title">周五，阿里巴巴杭州举办&OpenCurlyDoubleQuote;世界级&rdquo;年会！14班火车专列！100多次航班！1700车次大巴！7000个酒店房间！亮点无数！</a>
					<div>
						9月8日,本周五晚上,阿里巴巴集团将在黄龙体育中心召开2017集团年会,来自全球各地的数万名员工都将齐聚杭州. 在目前阿里巴巴6万多名员工中,只有近4万名员工能够到现场参加年会,他们是抽签抽中的.之所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZXldb.html" rel="bookmark" class="title">打印机无法删除问题？？</a>
					<div>
						问题描述 打印机无法删除问题?? 我的电脑换了一个工位 重新绑定了一个IP 打印机里面多了好多重定向的打印机还删除不了 提示拒绝访问无法删除 求高手指点 解决方案 删除设备 然后重新启动服务试试 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVaN8b.html" rel="bookmark" class="title">浏览器抓包篡改</a>
					<div>
						问题描述 抓取所有浏览器的数据包(服务器返回的html源码),对抓取到的源码,进行部分的修改后返还给浏览器,这样的需求谁涉及过呢?可以指点一下吗? 解决方案 解决方案二:Fiddler解决方案三:Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx2wkb.html" rel="bookmark" class="title">【C&sol;C&plus;&plus;学院】（29）网络编程--实现跨平台传输文件（TCP版）</a>
					<div>
						网络编程--实现跨平台传输文件(TCP版)源码下载地址     为了实现跨平台,需要对跨平台的代码进行条件编译. gcc的-D选项. 连接选项 -lWs2_32 代表要用Ws2_32.lib这个库 g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZBxNb.html" rel="bookmark" class="title">这么做myeclipse 6&period;5 注册</a>
					<div>
						问题描述 我安装了myeclipse6.5只有30天使用权请问这么注册长期使用?谢谢! 解决方案 解决方案二:一般都用这个http://download.csdn.net/source/2854849 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV1xBb.html" rel="bookmark" class="title">Java的RMI远程方法调用实现和应用</a>
					<div>
						最近在学习Dubbo,RMI是很重要的底层机制,RMI(Remote Method Invocation)远程方法调用是一种计算机之间利用远程对象互相调用实现双方通讯的一种通讯机制.使用这种机制,某一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm6xAb.html" rel="bookmark" class="title">Git简单应用</a>
					<div>
						First time using Git(首次用git) cd myproject git init # add all your files. Use can use specific filena ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRyY2p.html" rel="bookmark" class="title">渡虎谷参赛选手访谈：Windear与渡虎谷密谋</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 吴伟定,网名Windear,SEO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKD1ab.html" rel="bookmark" class="title">一例域名投资成功的案例分析</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 做站长的都知道,建设一个成功的域名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDjAkz.html" rel="bookmark" class="title">android 调用第三方apk setResult回来intent为null</a>
					<div>
						问题描述 android 调用第三方apk setResult回来intent为null 有2个程序互相调用,A程序通过发intent,使用startActivityForResult()方法, 调用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNyGdM.html" rel="bookmark" class="title">一个月没有解决的问题&period;如何更新记录到数据库中&period;</a>
					<div>
						问题描述 PublicSubUpdateRow()DimstrSqlAsStringDimobjDataAdapterAsNewOleDbDataAdapterDimobjDataSetAsNewDa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBgn2M.html" rel="bookmark" class="title">PostgreSQL GIN索引实现原理</a>
					<div>
						标签 PostgreSQL , GIN , 内核 , 实现原理 , PostgreSQL数据库内核分析 背景 本文参考并扩展自如下文档,修正了一些内容(大多数是由于版本不同造成的差异) &lt;Pos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWW557M.html" rel="bookmark" class="title">java static问题 求大神解释</a>
					<div>
						问题描述 java static问题 求大神解释 求解 错误在哪里 求大神帮忙 凑字数凑字数凑字数 凑字数凑字数凑字数 解决方案 static的方法 不能使用非静态的方法.你把Circle c = n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXA5Bb.html" rel="bookmark" class="title">SDN&sol;NFV部署大势所趋 看运营商如何加快步伐？</a>
					<div>
						近年来,随着SDN/NFV作为全局性.颠覆性的变革技术越来越被业内接受,全球运营商对其部署力度也愈发增加,大规模商用部署已成为大势所趋.调查报告显示,到2020年,仅欧美两地的主要电信运营商在SDN/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkXZBp.html" rel="bookmark" class="title">Android笔记之&colon;App应用之发布各广告平台版本的详解&lowbar;Android</a>
					<div>
						Android的广告平台是很多的,各市场对各平台的接受程度是不一样的,Android的开发者如果想集成广告基本要考虑下面两个问题:(1)集成什么广告,会赚钱?(2)集成什么广告,不会被市场拒绝?最终的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYq6Nb.html" rel="bookmark" class="title">ASP&period;NET对SQLServer的通用数据库访问类&lowbar;实用技巧</a>
					<div>
						本文模仿实现数据库访问的通用类,代码清晰,而且很实用,包括了对数据库的所有的常用的操作. /// &lt;summary&gt; /// 数据库访问通用类 /// &lt;/summary&gt; p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkXD4M.html" rel="bookmark" class="title">免费的ip数据库淘宝IP地址库简介和PHP调用实例&lowbar;php实例</a>
					<div>
						一.关于淘宝IP地址库 我们目前提供的服务包括:1. 根据用户提供的IP地址,快速查询出该IP地址所在的地理信息和地理相关的信息,包括国家.省.市和运营商.2. 用户可以根据自己所在的位置和使用的IP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1nq3b.html" rel="bookmark" class="title">PHP实现获取中英文首字母&lowbar;php实例</a>
					<div>
						PHP实现获取中英文按照首字母 /** * */ function getfirstchar($s0){ if($s0[0]=='I' || $s[0]=='i'){ return &quot;I&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NLB5p.html" rel="bookmark" class="title">Alexa&period;com 的排名原理</a>
					<div>
						所谓入门级网站,就是访问量在500到5000之间的网站,一般来说,进入这个级数的网站需要了解alexa的排名原理,具体的情况请www.alexa.com研究一下,不过这个监测软件有如下的问题,必须明白 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
